﻿(function(){
function colorToStyle(a,b,c){
var my_doc = app.activeDocument;

//////ここから文字スタイルグループを追加（重複がない場合のみ）//////
function characterStyleGroups_add( b ) {
var my_characterStyleGroups = false;//初期値
	//同名ならfalseを返す
	for (i = 0; i < my_doc.characterStyleGroups.length; i++) {
		if (my_doc.characterStyleGroups[i].name == b ) {return false;}
	}
	//characterStyleGroupsの作成
	my_characterStyleGroups = my_doc.characterStyleGroups.add();
    my_doc.characterStyleGroups[i].name = b ;
	return my_characterStyleGroups;
}
//文字スタイルグループを追加の実行
characterStyleGroups_add( b );

//////ここから文字スタイルを追加（重複がない場合のみ）//////
function characterStyles_add( b,c ) {
var my_characterStyles = false;//初期値
	//同名ならfalseを返す
	for (i = 0; i < my_doc.characterStyleGroups.itemByName( b ).characterStyles.length; i++) {
		if (my_doc.characterStyleGroups.itemByName(  b ).characterStyles[i].name == c ) {return false;}
	}
	//characterStylesの作成
	my_characterStyles = my_doc.characterStyleGroups.itemByName( b ).characterStyles.add();
    my_doc.characterStyleGroups.itemByName( b ).characterStyles[i].name = c ;
	return my_characterStyles;
}
//文字スタイルを追加の実行
characterStyles_add( b , c ) ;

//////ここから文字スタイルを適用//////
app.changeGrepPreferences = NothingEnum.nothing;//検索の設定クリア
app.findGrepPreferences = NothingEnum.nothing;//置換の設定クリア
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか
function apply_style(a,b,c) {//a:スウォッチ名・b:文字スタイルのグループ名・c:文字スタイル名
	var my_doc = app.activeDocument;//ターゲットドキュメント
	for (i = 0; i < my_doc.swatches.length; i++) {
		if (my_doc.swatches[i].name == a) {
            app.findGrepPreferences.fillColor= a ;
            app.changeGrepPreferences.appliedCharacterStyle = my_doc.characterStyleGroups.itemByName( b ).characterStyles.itemByName( c );
            app.changeGrep();
            my_doc.swatches[i].remove();
            app.changeGrepPreferences = NothingEnum.nothing;//検索の設定クリア
            app.findGrepPreferences = NothingEnum.nothing;//置換の設定クリア
            }
	}
}
apply_style( a , b , c );
}
///ここから実行（"スウォッチ名","文字スタイルグループ名","文字スタイル名"）///
///ここを書き換えるだけ///
colorToStyle("Word_R128_G0_B0" , "Group" , "style1");//濃い赤
colorToStyle("Word_R255_G0_B0" , "Group" , "style2");//赤
colorToStyle("Word_R255_G102_B0" , "Group" , "style3");//オレンジ
colorToStyle("Word_R255_G255_B0" , "Group" , "style4");//黄
colorToStyle("Word_R204_G255_B204" , "Group" , "style5");//薄い緑
colorToStyle("Word_R0_G128_B0" , "Group" , "style6");//緑
colorToStyle("Word_R51_G102_B255" , "Group" , "style7");//薄い青
colorToStyle("Word_R0_G0_B255" , "Group" , "style8");//青
colorToStyle("Word_R0_G0_B144" , "Group" , "style9");//濃い青
colorToStyle("Word_R102_G0_B102" , "Group" , "style0");//濃い紫

})();