﻿(function(){
function colorToStyle(a,b,c){
var my_doc = app.activeDocument;

//////ここから文字スタイルグループを追加（重複がない場合のみ）//////
function characterStyleGroups_add( b ) {
var my_characterStyleGroups = false;//初期値
	//同名ならfalseを返す
	for (i = 0; i < my_doc.characterStyleGroups.length; i++) {
		if (my_doc.characterStyleGroups[i].name == b ) {return false;}
	}
	//characterStyleGroupsの作成
	my_characterStyleGroups = my_doc.characterStyleGroups.add();
    my_doc.characterStyleGroups[i].name = b ;
	return my_characterStyleGroups;
}
//文字スタイルグループを追加の実行
characterStyleGroups_add( b );

//////ここから文字スタイルを追加（重複がない場合のみ）//////
function characterStyles_add( b,c ) {
var my_characterStyles = false;//初期値
	//同名ならfalseを返す
	for (i = 0; i < my_doc.characterStyleGroups.itemByName( b ).characterStyles.length; i++) {
		if (my_doc.characterStyleGroups.itemByName(  b ).characterStyles[i].name == c ) {return false;}
	}
	//characterStylesの作成
	my_characterStyles = my_doc.characterStyleGroups.itemByName( b ).characterStyles.add();
    my_doc.characterStyleGroups.itemByName( b ).characterStyles[i].name = c ;
	return my_characterStyles;
}
//文字スタイルを追加の実行
characterStyles_add( b , c ) ;

//////ここから文字スタイルを適用//////
app.changeGrepPreferences = NothingEnum.nothing;//検索の設定クリア
app.findGrepPreferences = NothingEnum.nothing;//置換の設定クリア
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか
function apply_style(a,b,c) {//a:スウォッチ名・b:文字スタイルのグループ名・c:文字スタイル名
	var my_doc = app.activeDocument;//ターゲットドキュメント
	for (i = 0; i < my_doc.swatches.length; i++) {
		if (my_doc.swatches[i].name == a) {
            app.findGrepPreferences.fillColor= a ;
            app.changeGrepPreferences.appliedCharacterStyle = my_doc.characterStyleGroups.itemByName( b ).characterStyles.itemByName( c );
            app.changeGrep();
            my_doc.swatches[i].remove();
            app.changeGrepPreferences = NothingEnum.nothing;//検索の設定クリア
            app.findGrepPreferences = NothingEnum.nothing;//置換の設定クリア
            }
	}
}
apply_style( a , b , c );
}
///ここから実行（"スウォッチ名","文字スタイルグループ名","文字スタイル名"）///
///ここを書き換えるだけ///
colorToStyle("Blue" , "Group" , "style1");//ブルー
colorToStyle("RTF r153 g102 b51" , "Group" , "style2");//ブラウン
colorToStyle("Turquoise" , "Group" , "style3");//シアン
colorToStyle("Bright Green" , "Group" , "style4");//グリーン
colorToStyle("Pink" , "Group" , "style5");//マゼンタ
colorToStyle("RTF r255 g128 b0" , "Group" , "style6");//オレンジ
colorToStyle("Violet" , "Group" , "style7");//パープル
colorToStyle("Red" , "Group" ,"style8");//レッド
colorToStyle("R=255 G=255 B=0" , "Group" , "style9");//イエロー

})();